---
- name: Set hostname
  hostname:
    name: "{{ inventory_hostname_short }}"

- name: Insert hosts file
  copy:
    dest: /etc/hosts
    backup: yes
    content: |
      127.0.0.1 localhost
      ::1       localhost ip6-localhost ip6-loopback
      ff02::1   ip6-allnodes
      ff02::2   ip6-allrouters
      {{ ansible_host }}  {{ inventory_hostname_short }} {{ inventory_hostname }}
  delegate_to: "{{ temp_ip|d(inventory_hostname) }}"

- name: Insert net config in /etc/network/interfaces
  copy:
    dest: /etc/network/interfaces
    content: |
      source-directory /etc/network/interfaces.d
      auto {{ standard_iface_name }}
      iface {{ standard_iface_name }} inet static
              address {{ ansible_host }}
              netmask {{ standard_ip_mask }}
              gateway {{ standard_default_gateway }}
              mtu 1346
    backup: yes
  register: network_config_file
  delegate_to: "{{ temp_ip|d(inventory_hostname) }}"

- name: Network interface validator  # noqa: 503
  command: ifup -a --no-act
  register: network_interface_validator
  delegate_to: "{{ temp_ip|d(inventory_hostname) }}"
  changed_when: false
  failed_when: network_interface_validator.rc > 0

- name: Network interface restart if needed
  shell: >
           ip addr flush {{ standard_iface_name | quote }}
           && ifdown {{ standard_iface_name | quote }} --force || true
           && ifup {{ standard_iface_name | quote }}
  async: 1
  poll: 0
  delegate_to: "{{ temp_ip|d(inventory_hostname) }}"
  changed_when: false

- name: Wait for server to be up on it ip address
  wait_for_connection:
    sleep: 20
    timeout: 300

- name: Insert dns config in /etc/resolv.conf
  copy:
    dest: /etc/resolv.conf
    content: |
      nameserver {{ dnsserver1 }}
      nameserver {{ dnsserver2 }}

- name: Restart networking service
  ansible.builtin.systemd:
    state: restarted
    name: networking
  changed_when: false

- name: Wait for server to be up on it ip address
  wait_for_connection:
    sleep: 20
    timeout: 300

- name: "Gathering Facts (if not been done before)"
  setup:
  when: ansible_facts.architecture is not defined
